/* Dimostra l'effetto del file descriptor
 * flag FD_CLOEXEC
 */

#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Defines
#define MYAPP "[cloexec]"
#define PARENT "<parent>"
#define CHILD  "<child>"
#define MYFILE "filetest"

#define PRINT_HELP printf("Usage: %s <executable file>\n", argv[0])

// Main function
int main(int argc, char **argv)
{
  pid_t pid;
  char pMsg[]=PARENT;
  char cMsg[]=CHILD;
  char *p;
  int fdFlag;

  if (argc < 2) {
    PRINT_HELP;
    exit(-1);
  }

  /* Stampa il PID e il PPID */  
  printf("%s Process ID is %d\n",MYAPP,(int)getpid());
  printf("%s Parent process ID is %d\n\n",MYAPP,(int)getppid());

  /* Abilita il bit FD_CLOEXEC del file descriptor flag, 
     prima leggendo il flag e poi settando il bit in questione */
  if ((fdFlag = fcntl(STDOUT_FILENO, F_GETFD, 0)) < -1) {
    perror(MYAPP "ERROR");    
    exit(-1);
  }

  if ((fcntl(STDOUT_FILENO,F_SETFD,fdFlag | FD_CLOEXEC)) == -1) {
    perror(MYAPP "ERROR");
    exit(-1);
  }
  else {
    printf("%s: close-on-exec bit has been set on fd=%d\n",MYAPP,STDOUT_FILENO);
  }

  pid=fork();
  switch (pid) {
  case 0: // child process
    p=cMsg;
    printf("%s%s Just before execlp()\n",MYAPP,p);
    if (execlp(argv[1], argv[1], NULL)==-1)
      perror(MYAPP " ERROR");
    printf("%s%s Just after execlp()\n",MYAPP,p);
    break;
  case -1: // error in fork()
    perror(MYAPP "Error calling fork: ");
    break;
  default: // parent process
    p=pMsg;    
    break;
  }

  // Parent process has the stdout still open */
  printf("%s%s This printf should be printed correctly\n",MYAPP,p);

  exit(0);
}
