#ifndef __file_matrix_h__
#define __file_matrix_h__

#include "matrix.h"

/*
 * Salva l'header della matrice sul file con
 * descrittore 'fd'
 * In caso di errore ritorna -1 altrimenti 0
 */
int matrix_save(int fd, struct matrix_header *mh);

/*
 * Carica l'header della matrice dal file con
 * descrittore 'fd'
 * In caso di errore ritorna -1 altrimenti 0
 */
int matrix_load(int fd, struct matrix_header *mh);

/*
 * Carica in 'value' l'elemento [i][j] della matrice
 * In caso di errore ritorna -1 altrimenti 0
 */
int matrix_get_element(int fd, struct matrix_header *mh, int i, int j, int *value);

/*
 * Salva l'elemento 'value' nella posizione [i][j]
 * In caso di errore ritorna -1 altrimenti 0
 */
int matrix_put_element(int fd, struct matrix_header *mh, int i, int j, int value);

/*
 * Carica in 'value' l'elemento seguente della matrice (dal puntatore corrente)
 * In caso di errore ritorna -1 altrimenti 0
 */
int matrix_get_next_element(int fd, int *value);

/*
 * Salva l'elemento 'value' nella posizione seguente della matrice (dal puntatore corrente)
 * In caso di errore ritorna -1 altrimenti 0
 */
int matrix_put_next_element(int fd, int value);

#endif /* !__file_matrix_h__ */
