#include "split.h"

#define DEFAULT_PREFIX "a_"

#define PRINT_HELP printf("Usage: %s <-b byte|-k kbyte|-m mbyte> <input file> [output prefix]\n", argv[0])

int main(int argc, char **argv) {
  int c;
  int split_size; /* Dimensione in bytes */
  char *in_file;  /* Nome del file di input */
  char *out_pre; /* Prefisso dei file di output */

  split_size = -1;

  while ((c = getopt(argc, argv, "b:k:m:h")) != -1) {
	switch (c) {
	case 'b':
	  if (split_size != -1) {
		PRINT_HELP;
		return 1;
	  }
	  split_size = atoi(optarg);
	  break;

	case 'k':
	  if (split_size != -1) {
		PRINT_HELP;
		return 1;
	  }
	  split_size = atoi(optarg) * 1024;
	  break;

	case 'm':
	  if (split_size != -1) {
		PRINT_HELP;
		return 1;
	  }
	  split_size = atoi(optarg) * 1024 * 1024;
	  break;
	  
	case 'h':
	  PRINT_HELP;
	  return 0;

	default:
	  printf("getopt returned character code 0%o\n", c);
	  return 1;
	}
  }

  if (split_size == -1) {
	PRINT_HELP;
	return 1;
  }

  if (optind < argc) {
	in_file = argv[optind++];
  } else {
	PRINT_HELP;
	return 1;
  }	

  out_pre = (optind < argc) ? argv[optind] : DEFAULT_PREFIX;

  return split(split_size, in_file, out_pre);
}
