#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "split.h"

#define MAX_NAME 64

static int write_part(ssize_t size, const void *buf, const char *out_pre, int id);

int split(int split_size, const char *in_file, const char *out_pre) {
  unsigned char *buffer;
  int fd, id;
  ssize_t size;

  /* Alloca memoria per il buffer */

  /* Apri il file di input in sola lettura */

  /* Leggi il file e crea le parti */
  id = 0;
  while ((size = read(fd, buffer, split_size)) > 0) {
	if (write_part(size, buffer, out_pre, id++)) {
	  close(fd);
	  free(buffer);
	  return -1;
	}
  }

  /* Libera la memoria */
  free(buffer);

  /* Controlla eventuali errori sulla read */
  if (size < 0) {
	perror(in_file);
	close(fd);
	return -1;
  }

  /* Chiude il file */
  if (close(fd) < 0) {
	perror(in_file);
	return -1;
  }

  return 0;
}

static int write_part(ssize_t size, const void *buf, const char *out_pre, int id) {
  char out_file[MAX_NAME];
  int fd;

  if (snprintf(out_file, MAX_NAME, "%s%03d", out_pre, id) < 0) {
	perror("Output filename");
	return -1;
  }

  /* Apre il file in scrittura */

  /* Scrive i dati sul file */

  /* Chiude il file */

  printf("Written %s\n", out_file);
  return 0;
}
